package com.extensiblejava.core.employee;

import java.util.Date;

import com.extensiblejava.core.employee.builder.Builder;

public class Employee {
	private Name name;
	private Employee manager;
	private Integer mgrId;
	private Employee staff[];
	private Integer empId;
	private Double rate;
	private Date startDate;
	private Date endDate;
	private String dept;
	private String pos;
	private String type;
	private Builder builder;

	public Employee(Integer empId, Integer mgrId, String dept, String pos, String type, Double rate, Name name, Builder builder) {
		this.empId = empId;
		this.mgrId = mgrId;
		this.dept = dept;
		this.pos = pos;
		this.type = type;
		this.rate = rate; 
		this.name = name;
		this.builder = builder;
	}
	public Employee getManager() {
		if (this.manager == null) {
			//load manager...
			//this.manager = new Employee(mgrId);
			this.manager = builder.buildManager();
		}
		
		return manager;	
	}
	
	public Employee[] getStaff() {
		if (this.staff == null) {
			this.staff = builder.buildStaff();	
		}
		return this.staff;
	}
	public Name getName() {
		return this.name;	
	}

}
