package com.extensiblejava.core.employee.builder.imp;

import com.extensiblejava.core.employee.Employee;
import com.extensiblejava.core.employee.Name;
import com.extensiblejava.core.employee.builder.Builder;
import com.extensiblejava.core.employee.selectable.SingleEmployeeSelectable;
import com.extensiblejava.core.employee.selectable.StaffEmployeeSelectable;
import com.extensiblejava.dao.*;
import com.extensiblejava.dao.mediator.*;



public class PartBuilder implements Builder {

	Integer empId;
	Integer mgrId;
	
	public PartBuilder(Integer empId) {
		this.empId = empId;	
	}
	
	public Employee buildEmployee() {
		//this.empId = empId;
		try {
			DAOMediator mediator = new DAOMediator();
			SingleEmployeeSelectable selectable = new SingleEmployeeSelectable(empId);
			DataCursor cursor = mediator.select(selectable);
			
			cursor.next();
			this.mgrId = new Integer((String) cursor.getValue("MGR_ID"));
			//this.startDate = (Date) cursor.getValue("START_DT");
			//this.endDate = (Date) cursor.getValue("END_DT");
			String dept = (String) cursor.getValue("DEPARTMENT_CD");
			String pos = (String) cursor.getValue("POSITION_CD");
			String type = (String) cursor.getValue("TYPE_CD");
			Double rate = new Double((String) cursor.getValue("RATE"));
			String firstName = (String) cursor.getValue("FIRST");
			String lastName = (String) cursor.getValue("LAST");
			Name name = new Name(firstName, lastName);
			return new Employee(empId, mgrId, dept, pos, type, rate, name, this);
		} catch (TransactionException e) {
			e.printStackTrace();
		} catch (DAOException e) {
			e.printStackTrace();
		}
		return null;
	}

	public Employee buildManager() {
		if (this.mgrId.intValue() != 0) {
			PartBuilder partBuilder = new PartBuilder(this.mgrId);
			return partBuilder.buildEmployee();
		} else { return null; }
	}

	public Employee[] buildStaff() {
		
		try {
			DAOMediator mediator = new DAOMediator();
			StaffEmployeeSelectable selectable = new StaffEmployeeSelectable(this.empId);
			DataCursor cursor = mediator.select(selectable);
			Employee staff[] = new Employee[cursor.numRows()];
			int i = 0;
			while (cursor.next()) {
				Integer empId = new Integer((String) cursor.getValue("ID"));
				Integer mgrId = new Integer((String) cursor.getValue("MGR_ID"));
			//this.startDate = (Date) cursor.getValue("START_DT");
			//this.endDate = (Date) cursor.getValue("END_DT");
				String dept = (String) cursor.getValue("DEPARTMENT_CD");
				String pos = (String) cursor.getValue("POSITION_CD");
				String type = (String) cursor.getValue("TYPE_CD");
				Double rate = new Double((String) cursor.getValue("RATE"));
				String firstName = (String) cursor.getValue("FIRST");
				String lastName = (String) cursor.getValue("LAST");
				Name name = new Name(firstName, lastName);
				staff[i] = new Employee(empId, mgrId, dept, pos, type, rate, name, new PartBuilder(empId));
				i++;
			}
			return staff;
		} catch (TransactionException e) {
			e.printStackTrace();
		} catch (DAOException e) {
			e.printStackTrace();
		}
		return null;
		
	}

}
