package com.extensiblejava.core.employee.selectable;

import com.extensiblejava.dao.*;
import java.util.*;

public class CompleteEmployeeSelectable implements Selectable {
	private Integer empId;
	private static String SQL = "select " +
				"emp.id, emp.mgr_id, emp.start_dt, emp.end_dt, emp.type_cd, emp.rate, emp.position_cd, "+ 
				"emp.department_cd, p.first, p.mid, p.last, p.dob, p.ssn, 'EMP' type " +
				"from  " +
				"employee emp, " +
				"person p " +
				"where " +
				"emp.id = ? and " +
				"emp.name_id = p.id " +
				"union select  " +
				"emp.id, emp.mgr_id, emp.start_dt, emp.end_dt, emp.type_cd, emp.rate, emp.position_cd, "+ 
				"emp.department_cd, p.first, p.mid, p.last, p.dob, p.ssn, 'STF' type " +
				"from  " +
				"employee emp, " +
				"person p " +
				"where " +
				"emp.mgr_id = ? and " +
				"emp.name_id = p.id " +
				"union select " +
				"emp.id, emp.mgr_id, emp.start_dt, emp.end_dt, emp.type_cd, emp.rate, emp.position_cd, "+ 
				"emp.department_cd, p.first, p.mid, p.last, p.dob, p.ssn, 'MGR' type " +
				"from " +
				"employee emp, " +
				"	employee mgr, " +
				"	person p " +
				"where " +
				"	emp.id = ? and " +
				"	emp.mgr_id = mgr.id and " +
				"	mgr.name_id = p.id ";
	public CompleteEmployeeSelectable(Integer empId) {
		this.empId = empId;	
	}
	public String getSelectSQL() {
		return CompleteEmployeeSelectable.SQL;
	}
	
	public SortedMap getSortedSelectValues() { 
		TreeMap map = new TreeMap(); 
		map.put(new Integer(1), this.empId);
		map.put(new Integer(2), this.empId);
		map.put(new Integer(3), this.empId);
		return map;
	}

}
