package com.extensiblejava.core.employee.test;

import junit.framework.TestCase;
import com.extensiblejava.core.employee.*;
import com.extensiblejava.core.employee.builder.Builder;
import com.extensiblejava.core.employee.builder.imp.PartBuilder;
import com.extensiblejava.core.employee.builder.imp.CompleteBuilder;

public class TestEmployeeBuild extends TestCase {

	protected void setUp() throws Exception {

	}

	public TestEmployeeBuild(String s) {
		super(s);
	}
	
	public void testMock() throws Exception {
		System.out.println();System.out.println("TESTING MOCK BUILDER");
		Builder builder = new MockBuilder();
		Employee e = builder.buildEmployee();
		Name name = e.getName();
		System.out.println("EMP: " + name.getFullName());

		Employee mgr = e.getManager();
		Name mgrName = mgr.getName();
		System.out.println("MGR: " + mgrName.getFullName());
		Employee staff[] = e.getStaff();
		for (int i = 0; i < staff.length; i++) {
			System.out.println("STAFF: " + staff[i].getName().getFullName());
		}	
	}

	public void testPartBuilder() throws Exception {
		System.out.println();System.out.println("TESTING PART BUILDER");
		Builder builder = new PartBuilder(new Integer(2));
		Employee e = builder.buildEmployee();
		Name name = e.getName();
		System.out.println("EMP: " + name.getFullName());

		Employee mgr = e.getManager();
		if (mgr != null) {
			Name mgrName = mgr.getName();
			System.out.println("MGR: " + mgrName.getFullName());
		} else {
			System.out.println("No MGR");	
		}
		

		Employee staff[] = e.getStaff();
		for (int i = 0; i < staff.length; i++) {
			System.out.println("STAFF: " + staff[i].getName().getFullName());
			Employee subStaff[] = staff[i].getStaff();
			for (int j = 0; j < subStaff.length; j++){
				System.out.println("SUBSTAFF: " + subStaff[j].getName().getFullName());
			}
		}	
	}

	public void testCompleteBuilder() throws Exception {
		System.out.println();System.out.println("TESTING COMPLETE BUILDER");
		Builder builder = new CompleteBuilder(new Integer(2));
		Employee e = builder.buildEmployee();
		Name name = e.getName();
		System.out.println("EMP: " + name.getFullName());

		Employee mgr = e.getManager();
		if (mgr != null) {
			Name mgrName = mgr.getName();
			System.out.println("MGR: " + mgrName.getFullName());
		} else {
			System.out.println("No MGR");	
		}

		Employee staff[] = e.getStaff();
		for (int i = 0; i < staff.length; i++) {
			System.out.println("STAFF: " + staff[i].getName().getFullName());
			Employee subStaff[] = staff[i].getStaff();
			for (int j = 0; j < subStaff.length; j++){
				System.out.println("SUBSTAFF: " + subStaff[j].getName().getFullName());
			}
		}	
	}
}
