package com.extensiblejava.dao;
import java.sql.*;
import java.util.*;

public final class DataBaseDAO extends BaseDAO {
	private static DataBaseDAO instance;
	private DataBaseDAO() {}
	public synchronized static DataBaseDAO getInstance() {
		if (instance == null) {
			instance = new DataBaseDAO();	
		}
		return instance;		
	}
	public ResultSet executeSelect(Selectable selectable)
		throws SQLException, Exception {

		PreparedStatement ps = null;

		try {
			Connection conn = (Connection) this.getDBConnection();
			String sql = selectable.getSelectSQL();
			ps = conn.prepareStatement(sql);
			Iterator columnValues = selectable.getSortedSelectValues().values().iterator();
			int index = 1;
			while (columnValues.hasNext()) {
				Object value = columnValues.next();
				ps.setObject(index, value);
				index++;
			}

			ResultSet rs = ps.executeQuery();
			
			return rs;

		} catch (SQLException e) {
			throw e;
		} catch (Exception e) {
			throw e;	
		}
	}
}