package com.extensiblejava.dao;
import java.sql.*;
import java.util.*;

public final class DataBaseDAO extends BaseDAO {
	private static DataBaseDAO instance;
	private DataBaseDAO() {
	}
	public synchronized static DataBaseDAO getInstance() {
		if (instance == null) {
			instance = new DataBaseDAO();
		}
		return instance;
	}
	public DataCursor executeSelect(Selectable selectable)
		throws DAOException {

		PreparedStatement ps = null;
		Connection conn = null;

		try {
			conn = (Connection) getDBConnection();
			String sql = selectable.getSelectSQL();
			ps = conn.prepareStatement(sql);
			Iterator columnValues =
				selectable.getSortedSelectValues().values().iterator();
			int index = 1;
			while (columnValues.hasNext()) {
				Object value = columnValues.next();
				ps.setObject(index, value);
				index++;
			}

			ResultSet rs = ps.executeQuery();

			TabularRecordSet dc = new TabularRecordSet(rs);

			return dc;

		} catch (SQLException ex) {
			throw new DAOException(ex);
		} catch (Exception e) {
			throw new DAOException(e);
		} finally {
			try {
				if (ps != null) {
					ps.close();
				}
				if (conn != null) {
					conn.close();
				}
			} catch (SQLException e) {
				throw new DAOException("Error closing,", e);
			}
		}
	}
}