package com.extensiblejava.dao;

import java.util.*;

public abstract class InsertableAdapter implements Insertable {
	private ArrayList listeners;

	public abstract String getInsertSQL();

	public abstract SortedMap getSortedInsertValues();

	public void registerListener(KeyListener listener) {
		if (this.listeners == null) {
			this.listeners = new ArrayList();	
		}
		listeners.add(listener);
	}

	public void notifyListeners(Integer keyValue) {
		if (listeners != null) {
			Iterator iterator = listeners.iterator();
			while (iterator.hasNext()) {
				KeyListener listener = (KeyListener) iterator.next();
				listener.updateKey(keyValue);
			}	
		}

	}

}
