package com.extensiblejava.dao;

import java.util.*;

public class NoBindDecorator extends SelectableDecorator {
	
	public NoBindDecorator(Selectable selectable) {
		super(selectable);		
	}
	
	public String getSelectSQL() {
		String sql = super.getSelectSQL();
		SortedMap bindVariables = super.getSortedSelectValues();
		return this.parseSQL(sql, bindVariables);
	}
	
	public SortedMap getSortedSelectValues() {
		return new TreeMap();	
	}
	
	private String parseSQL(String sql, SortedMap bindVariables) {
		StringBuffer sqlBuffer = new StringBuffer();
		StringTokenizer tokenizer = new StringTokenizer(sql, "?", false);
		
		if (!tokenizer.hasMoreElements()) {
			return sql;
		}
		
		Iterator variables = bindVariables.values().iterator();
		while (tokenizer.hasMoreTokens()) {
			sqlBuffer.append(tokenizer.nextToken());
			
			if (variables.hasNext()) {
				Object value = variables.next();
				if ( (value instanceof String) || (value instanceof Date) ) {
					sqlBuffer.append("'" + value + "'");
				} else {
					sqlBuffer.append(value);
				}
			}
		}
		return sqlBuffer.toString();
	}
	
	public String toString() {
		return this.getSelectSQL();		
	}

}
