package com.extensiblejava.dao.test;

import junit.framework.TestCase;
import java.util.*;
import com.extensiblejava.dao.*;
import com.extensiblejava.dao.mediator.*;

public class TestPrimaryKeySelectable extends TestCase {
	
	public TestPrimaryKeySelectable(String s){
		super(s);
	}
	public static void main(String[] args) {
		junit.textui.TestRunner.run(TestPrimaryKeySelectable.class);

	}
	
	public void testKeySelectable() {
		
		InsertableAdapter person = new InsertableAdapter() {
			public String getInsertSQL() {
				return "insert into person (first, last, dob, ssn) " +
				"values ('Jason', 'Johnson', '1970-01-01', '999999999')";	
			}
			public SortedMap getSortedInsertValues() {
				return new TreeMap();	
			}
		};
		
		try {
			DAOMediator mediator = new DAOMediator();
			class MyKeyListener implements KeyListener {
				private Integer keyValue;
				public void updateKey(Integer keyValue) {
					this.keyValue = keyValue;
					//System.out.println("KEY VALUE: " + keyValue);
				}	
				public Integer getKey() {return this.keyValue;}
			}
			mediator.addInsertable(person);
			MyKeyListener newKey = new MyKeyListener();
			person.registerListener(newKey);
			mediator.insert();
			System.out.println(newKey.getKey());
			assertNotNull(newKey.getKey());
		} catch (Exception e) {
			fail(e.toString());	
		}
		
		
	}
}

