package com.extensiblejava.dao.test;

import junit.framework.TestCase;
import com.extensiblejava.dao.*;
import java.sql.*;

public class TestSelectable extends TestCase {
	
	public TestSelectable(String s){
		super(s);
	}
	public static void main(String[] args) {
		junit.textui.TestRunner.run(TestSelectable.class);

	}
	
	public void testSelectWithParms() {
		try {
			DataBaseDAO dao = new DataBaseDAO();
			Selectable select = new Selectable() {
				public String getSelectSQL() {
					return "select * from employee where id = ? and type_cd = ?";
				}
				public java.util.SortedMap getSortedSelectValues() {
					java.util.TreeMap map = new java.util.TreeMap();
					map.put(new Integer(1), new Integer(1));
					map.put(new Integer(2), "01");
					return map;
				}
			};
			ResultSet rs = dao.executeSelect(select);
			while (rs.next()) {
				System.out.println(rs.getString(1));
			}
		} catch (SQLException e) {
			fail("ERROR SELECTING");
		} catch (Exception e) {
			fail("ERROR");	
		}
	}

	public void testSelectWithNoParms() {
		try {
			DataBaseDAO dao = new DataBaseDAO();
			Selectable select = new Selectable() {
				public String getSelectSQL() {
					return "select p.first, p.last, e.start_dt, type.description, " +
	        			"pos.description, dept.description " +
						"from  " +
						"employee e, reference type, reference pos,	reference dept,	person p " +
						"where " + 
						"e.name_id = p.id and " + 
						"e.type_cd = type.type_cd and " + 
						"type.category_cd = 'EMPTYP' and " +
						"e.position_cd = pos.type_cd and " +
						"pos.category_cd = 'EMPPOS' and " +
						"e.department_cd = dept.type_cd and " + 
						"dept.category_cd = 'EMPDPT'";
				}
				public java.util.SortedMap getSortedSelectValues() {
					return new java.util.TreeMap();
				}
			};
			ResultSet rs = dao.executeSelect(select);
			/*while (rs.next()) {
				System.out.println(rs.getString(1));
			}*/
		} catch (SQLException e) {
			fail("ERROR SELECTING");
		} catch (Exception e) {
			fail("ERROR");	
		}
	}
}

